# TP 11 (fichier à compléter) : Dichotomie
# BCPST1B 2024-2025
# Lycée Hoche, Versailles
# L.-C. LEFÈVRE

#%% exercice 1

from random import randint

def jeu():
    n = randint(1, ...)
    fini = False
    print("réponse :", n) # supprimer cette ligne quand le programme fonctionne bien
    while not fini:
        x = int(input("Nombre ? "))
        if ... :
            print("Plus grand !")
        elif ... :
            ...
        else:
            ...
            fini = True

# test
jeu()

#%% exercice 4.1

def racine(n):
    a = 1
    b = 2
    for ... :
        m = (a+b) / 2
        if ... :
            ...
        else:
            ...
        print(a, b)

# test
racine(10)

#%% exercice 4.2

def racine2(s):
    ...
    return (a, b)

# test
print(racine2(1e-6))

#%% exercice 4.3

def racine3(s, a, b):
    ...

# test
print(racine3(1e-6, 1, 2))

#%% exercice 5.1
# exécuter et observer !

import numpy as np
import matplotlib.pyplot as plt

X = np.linspace(-5, 5, 100)
Y = X**3 - 5*X - 3
Z = 0 * X
plt.grid(True)
plt.xlim(-5, 5)
plt.ylim(-10, 10)
plt.title("Exercice 5")
plt.plot(X, Y, color="blue", label="$f(x)$")
plt.plot(X, Z, color="red", label="$y=0$")
plt.legend()
plt.show()

#%% exercice 5.2

def solution1(s):
    ...

def solution2(s):
    ...

def solution3(s):
    ...

# test
print(solution1(1e-6))
print(solution2(1e-6))
print(solution3(1e-6))

#%% exercice 6.1
# exécuter et observer !

import numpy as np
import matplotlib.pyplot as plt

X = np.linspace(-8, 4, 100)
Y = np.exp(X)
T1 = 3 + 1/2*X
T2 = 3 + 1*X
T3 = 3 + 2*X
plt.grid(True)
plt.xlim(-8, 4)
plt.ylim(-1, 10)
plt.title("Exercice 6")
plt.plot(X, Y, color="blue", label="$e^x$")
plt.plot(X, T1, color="violet", label="$3+0.5 x$")
plt.plot(X, T2, color="darkviolet", label="$3+x$")
plt.plot(X, T3, color="purple", label="$3+2x$")
plt.legend()
plt.show()

#%% exercice 6.2

import math

def borne_x(t):
    ...

# test
print(borne_x(0.5))
print(borne_x(1))
print(borne_x(2))
print(borne_x(100))

#%%

def solution_x(t, s):
    ...

# test
print(solution_x(0.5, 1e-6))
print(solution_x(1, 1e-6))
print(solution_x(2, 1e-6))
print(solution_x(100, 1e-6))

#%%

def borne_y(t):
    ...

# test
print(borne_y(0.5))
print(borne_y(1))
print(borne_y(2))
print(borne_y(0.1))

#%%

def solution_y(t, s):
    ...

# test
print(solution_y(0.5, 1e-6))
print(solution_y(1, 1e-6))
print(solution_y(2, 1e-6))
    
#%% exercice 7

def est_croissante(L):
    ...

# test
print(est_croissante([1, 6, 8, 10]))
print(est_croissante([7, 3, 4, 6]))
print(est_croissante([1, 8, 3, 9]))

#%% exercice 8

def cherche_iteratif(L, x):
    ...

# test
L = [1, 5, 12, 13, 16, 18, 25, 30]
print(cherche_iteratif(L, 12))
print(cherche_iteratif(L, 1))
print(cherche_iteratif(L, 30))
print(cherche_iteratif(L, 14))
print(cherche_iteratif(L, -10))
print(cherche_iteratif(L, 45))

#%% exercice 9

def cherche_dichotomie(L, x):
    n = len(L)
    a = 0
    b = n - 1
    if x == L[a]:
        ...
    elif x == L[b]:
        ...
    elif x < L[a] or x > L[b]:
        ...
    while b-a > 1:
        m = ...
        if x == L[m]:
            return m
        elif ... :
            ...
        else:
            ...
    return ...

# tests
L = [1, 5, 12, 13, 16, 18, 25, 30]
print(cherche_dichotomie(L, 12))
print(cherche_dichotomie(L, 1))
print(cherche_dichotomie(L, 30))
print(cherche_dichotomie(L, 14))
print(cherche_dichotomie(L, -10))
print(cherche_dichotomie(L, 45))

#%% exercice 10
# exécuter une fois pour charger le fichier

with open("dictionnaire.txt", "r", encoding="utf-8") as f:
    dictionnaire = [s.strip() for s in f]
    dictionnaire.sort()
    print("longueur du dictionnaire:", len(dictionnaire))
    # extrait : un mot tous les 50000
    print(dictionnaire[::50000])

# la variable dictionaire est une liste de mots
    
#%% tests

# doit renvoyer True, sinon appeler à l'aide...
print(est_croissante(dictionnaire))

x = "python"
print(cherche_iteratif(dictionnaire, x))
print(cherche_dichotomie(dictionnaire, x))
x = "mathématiques"
print(cherche_iteratif(dictionnaire, x))
print(cherche_dichotomie(dictionnaire, x))
x = "téoraime"
print(cherche_iteratif(dictionnaire, x))
print(cherche_dichotomie(dictionnaire, x))
x = "dykotaumi"
print(cherche_iteratif(dictionnaire, x))
print(cherche_dichotomie(dictionnaire, x))
# à vous ...

#%% un calcul

import math
print(math.log(len(dictionnaire)) / math.log(2))

#%% exercice 11

import timeit
# choisir un mot
x = "mathématiques"
# la fonction à chronométrer ne doit pas contenir de print !!!
# la réponse est en secondes
#%%
print(timeit.timeit("cherche_iteratif(dictionnaire, x)", number=1000, globals=globals()))
#%%
print(timeit.timeit("cherche_dichotomie(dictionnaire, x)", number=1000, globals=globals()))
#%%
